<?php

/**
 * InstallController
 * 
 * @author
 * @version 
 */

require_once 'Zend/Controller/Action.php';
require_once 'admin/controllers/SettingController.php';

class Install_InstallController extends Admin_SettingController {
	public function indexAction()
	{
		$ns = new Zend_Session_Namespace(Precurio_Session::NAMESPACE_USER);
		$ns->unsetAll();
		return $this->_forward('general');
	}
	function getPageTitle() {
		return 'Precurio Installation';
	}
	public function preDispatch()
	{
		$this->_helper->layout->disableLayout();
		$this->view->page = $this->getRequest()->getActionName();
		$this->view->pageTitle = $this->view->translate($this->getPageTitle());
	}
	private function getNewUserForm($data)
	{
		
		$form = new Zend_Form();
		$form->setAction($this->getRequest()->getBaseUrl().'/install/install/finish')
			->setMethod('post')
			->setAttrib('id','form')
			->setAttrib('name','addForm')
			->setAttrib('enctype', 'multipart/form-data');
		
		$form->addElement('text', 'first_name', array(
				'required' => true,
				'label'=>'First Name',
				'value'=>$data['first_name']
				));	
				
		$form->addElement('text', 'last_name', array(
				'required' => true,
				'label'=>'Last Name',
				'value'=>$data['last_name']
				));	
				
		$form->addElement('text', 'email', array(
				'required' => true,
				'label'=>'Email',
				'value'=>$data['email']
				));			
		$form->addElement('password', 'password', array(
				'required' => true,
				'label'=>'Password',
				'renderPassword'=>true,
				'value'=>$data['password']
				));		
		return $form;
	}
	public function newuserAction()
	{
		$config = Zend_Registry::get('config');
		$params = array(
			'first_name' => 'Intranet',
			'last_name'=> 'Administrator',
			'email'=>'administrator'.(Precurio_Utils::isNull($config->email_domain) ? '' : $config->email_domain),
			'password'=>'admin'
		);
		$form = $this->getNewUserForm($params);
		$this->view->form = $form;
		$this->render('index');
	}
	public function finishAction()
	{
		Precurio_Session::logOut();//clears session.
		$this->createMysqlDb();
		
		$this->createMysqlTables();
		
		$this->loadStartData();
		
		$config = Zend_Registry::get('config');
		if($config->auth_mech == 'DatabaseAuth')
		{
			$params = $this->getRequest()->getParams();
	
			$form = $this->getNewUserForm($params);
			
			if (!$form->isValid($_POST))
			{
				// Failed validation; redisplay form
				$this->view->form = $form;
				$this->view->page = 'newuser';
				return $this->render('index');
			}
			
			$params = $form->getValues();
			$params['identity'] = $params['email'];
			$params['credential'] = md5($params['password']);unset($params['password']);
			$params['date_created'] = Precurio_Date::now()->getTimestamp();
			$this->createFirstUser($params);
		}
		
		$this->updateBatchFile();
		
		$this->_redirect('/login/login');
	}
	function updateBatchFile()
	{
		$this->_helper->viewRenderer->setNoRender();
		$root = Zend_Registry::get('root');
		$str = "php.exe -q $root/bin/daemon.php";
		
		$fd=fopen($root.'/bin/run.bat', "wb");
		$out=fwrite($fd,$str);
		fclose($fd); 
	}
	function createFirstUser($data)
	{
		$config = Zend_Registry::get('config');
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::AUTH));
		$user_id =  $table->insert(array(
			'identity' => $data['identity'],
			'credential' =>$data['credential'],
			'date_created'=>$data['date_created']
		));
		
		$params = array(
			'user_id'=>$user_id,
			'first_name'=>$data['first_name'],
			'last_name'=>$data['last_name'],
			'email'=>$data['email'],
			'username'=>stripos($data['email'],'@') === false ? $data['email'] : substr($data['email'],0,strpos($data['email'],'@')),
			'password'=>$data['credential'],
			'location_id'=>0,
			'department_id'=>0,
			'company'=>isset($config->company_name) ? $config->company_name : '',
			'date_created'=>$data['date_created'],
			'active'=>1,
		    'out_of_office'=>0
		);
		
		$id = UserUtil::createUser($params);
		return $user_id;
	}
	function loadStartData()
	{
		$root = Zend_Registry::get('root');
		$data = file_get_contents($root.'/application/install/models/data.sql');
		
		$db = Zend_Registry::get('db');
		$db->query($data);
	}
	function createMysqlTables()
	{
		$backup = new Precurio_Backup();
		$path = $backup->getPath();
		unset($backup);
		
		$dbStruct = file_get_contents($path.'struct.db');
		
		$db = Zend_Registry::get('db');
		$db->query($dbStruct);
	}
	function createMysqlDb()
	{
		$config = Zend_Registry::get('config');
    	
    	$active_db = $config->active_database;
    	$db_config = $config->mysql;
    	
    	$db_config = $db_config->toArray();
    	$db_config = $db_config['database'];
    	
    	$adapter = $db_config['adapter'];
    	$params = array();
		foreach ($db_config as $key=>$value) {
			if($key == 'adapter')continue;
			if($key == 'dbname') $value = 'mysql';//change the dbname to a database that will surely exist
			$params[$key] = $value;
		}

		$tempdb = Zend_Db::factory($adapter,$params);

		$dbName = $config->mysql->database->dbname;
		$createDbQuery = "
		SET NAMES utf8;
		
		SET SQL_MODE='';
		
		create database if not exists `$dbName`;
		
		USE `$dbName`;
		
		SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
		SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO';
		"; 
		
		$tempdb->query($createDbQuery);
		
		unset ($tempdb);//no more needed, our database has been created
		unset ($params);
		unset ($db_config);
		unset ($adapter);
		
	}
public function testdbAction()
	{
		$this->_helper->layout->disableLayout();
		$this->_helper->viewRenderer->setNoRender();
		
		$values = $_POST;
		$adapter = 'Pdo_Mysql';
		
    	$params = array(
    		'host'=>$values['host'],
    		'port'=>$values['port'],
    		'dbname'=>'mysql',
    		'username'=>$values['username'],
    		'password'=>$values['password']
    	);

		$db = Zend_Db::factory($adapter,$params);
		try 
		{
			$db->getConnection();
		}
		catch(Zend_Db_Exception $e)
		{
			echo ($e->getMessage());
			return;
		}
		catch(Zend_Exception $e)
		{
			echo ($e->getMessage());
			return;
		}
		$db->closeConnection();
		
		echo "Connection to database was Success!";
	}
}
?>