<?php

class Precurio_Activity {
	const ADD_PROFILE_PICTURE = 0;
	const CHANGE_PROFILE_PICTURE = 1;
	const CHANGE_PHONE_NUMBER = 2;
	const CHANGE_LOCATION = 3;
	const CHANGE_JOB_TITLE = 4;
	const CHANGE_DEPARTMENT = 5;
	const CHANGE_STATUS =  6;
	const ADD_COMMENT = 7;
	const ADD_EVENT = 8;
	const EDIT_EVENT = 9;
	const ADD_EVENT_PHOTO = 10;
	const SHARED_CONTACT = 11;
	const NEW_TASK  =12;
	const EDIT_TASK = 13;
	const COMPLETE_TASK = 14;
	const FAILED_TASK = 15;
	const CONTENT_APPROVED = 16;
	const CONTENT_REJECTED = 17;
	const TRANSFER_TASK = 18;
	const NEW_WORKFLOW_REQUEST = 19;
	const WORKLOW_APPROVAL_REQUEST = 20;
	const WORKFLOW_APPROVED = 21;
	const WORKFLOW_REJECTED = 22;
	const NEW_CONTENT = 23;
	const EDIT_CONTENT = 24;
	const EVENT_INVITED = 25;
	//%1\$s == name of actor
	//%2\$s == pronoun i.e his or her
	//%3\$s == url
	//%4\$s == name of subject.
	//%5\$s == the id of the actor
	//%6\$s = the id of the subject
	//%7\$s = web url of the application
	//%8\$s = a label for the activity, eg the event name, content name etc
	static $messageFormats = array(
		self::ADD_PROFILE_PICTURE=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> added a profile picture",
		self::CHANGE_PROFILE_PICTURE=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> changed %2\$s profile picture",
		self::CHANGE_PHONE_NUMBER=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> changed %2\$s phone number",
		self::CHANGE_LOCATION=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span>changed %2\$s location",
		self::CHANGE_JOB_TITLE=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> changed %2\$s job title",
		self::CHANGE_DEPARTMENT=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> changed %2\$s department",
		self::CHANGE_STATUS=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> %2\$s",
		self::ADD_COMMENT=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> commented on your activity :<br/> <a href='%3\$s'>click here</a> to view activity details",
		self::ADD_EVENT=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> added an event '%8\$s':<br/> <a href='%3\$s'>click here</a> to view event details",
		self::EDIT_EVENT=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> edited an event '%8\$s':<br/> <a href='%3\$s'>click here</a> to view event details",
		self::ADD_EVENT_PHOTO=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> edited a photo to event '%8\$s' :<br/> <a href='%3\$s'>click here</a> to view event it",
		self::SHARED_CONTACT=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> just shared a contact :<br/> <a href='%3\$s'>click here</a> to view contact details",
		self::NEW_TASK=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> just assigned a task to %4\$s :<br/> <a href='%3\$s'>click here</a> to view task details",
		self::EDIT_TASK=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> just edited the details of a task :<br/> <a href='%3\$s'>click here</a> to view new task details",
		self::COMPLETE_TASK=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> has completed a task :<br/> <a href='%3\$s'>click here</a> to view the details of the task",
		self::FAILED_TASK=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> failed to complete a task :<br/> <a href='%3\$s'>click here</a> to view the details of the task",
		self::CONTENT_APPROVED=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> approved your content for view :<br/><a href='%3\$s'>click here</a> to view your content",
		self::CONTENT_APPROVED=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> rejected your content for view :<br/><a href='%3\$s'>click here</a> to view your content",
		self::TRANSFER_TASK=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> just transfered a task to %4\$s :<br/><a href='%3\$s'>click here</a> to view task details",
		self::NEW_WORKFLOW_REQUEST=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> just created a new workflow request :<br/> <a href='%3\$s'>click here</a> to view.",
		self::WORKLOW_APPROVAL_REQUEST=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> have a new request for approval :<br/> <a href='%3\$s'>click here</a> to view.",
		self::WORKFLOW_APPROVED=>"  your workflow request has been approved by <span class='nameText'><a href='%7\$s/user/profile/view/%6\$s'>%4\$s </a></span> :<br/> <a href='%3\$s'>click here</a> to view workflow details",
		self::WORKFLOW_REJECTED=>"  your workflow request has been denied by<span class='nameText'><a href='%7\$s/user/profile/view/%6\$s'>%4\$s </a></span> :<br/><a href='%3\$s'>click here</a> to view workflow details",
		self::NEW_CONTENT=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> added a new content '%8\$s':<br/> <a href='%3\$s'>click here</a> to view content",
		self::EDIT_CONTENT=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> edited content '%8\$s':<br/> <a href='%3\$s'>click here</a> to view content",
		self::EVENT_INVITED=>"<span class='nameText'><a href='%7\$s/user/profile/view/%5\$s'>%1\$s </a></span> has invited you to event '%8\$s':<br/> <a href='%3\$s'>click here</a> to view event details"
		
		);
	static $activityTables = array(
		self::ADD_PROFILE_PICTURE=>PrecurioTableConstants::USERS,
		self::CHANGE_PROFILE_PICTURE=>PrecurioTableConstants::USERS,
		self::CHANGE_PHONE_NUMBER=>PrecurioTableConstants::USERS,
		self::CHANGE_LOCATION=>PrecurioTableConstants::USERS,
		self::CHANGE_JOB_TITLE=>PrecurioTableConstants::USERS,
		self::CHANGE_DEPARTMENT=>PrecurioTableConstants::USERS,
		self::CHANGE_STATUS=>PrecurioTableConstants::STATUS_MESSAGES,
		self::ADD_COMMENT=>PrecurioTableConstants::COMMENTS,
		self::ADD_EVENT=>PrecurioTableConstants::EVENT,
		self::EDIT_EVENT=>PrecurioTableConstants::EVENT,
		self::ADD_EVENT_PHOTO=>PrecurioTableConstants::EVENT,
		self::SHARED_CONTACT=>PrecurioTableConstants::CONTACTS,
		self::NEW_TASK=>PrecurioTableConstants::TASK,
		self::EDIT_TASK=>PrecurioTableConstants::TASK,
		self::COMPLETE_TASK=>PrecurioTableConstants::TASK,
		self::FAILED_TASK=>PrecurioTableConstants::TASK,
		self::CONTENT_APPROVED=>PrecurioTableConstants::CONTENT,
		self::CONTENT_REJECTED=>PrecurioTableConstants::CONTENT,
		self::TRANSFER_TASK=>PrecurioTableConstants::TASK,
		self::NEW_WORKFLOW_REQUEST=>PrecurioTableConstants::USER_PROCESS,
		self::WORKLOW_APPROVAL_REQUEST=>PrecurioTableConstants::USER_PROCESS,
		self::WORKFLOW_APPROVED=>PrecurioTableConstants::USER_PROCESS,
		self::WORKFLOW_REJECTED=>PrecurioTableConstants::USER_PROCESS,
		self::NEW_CONTENT=>PrecurioTableConstants::CONTENT,
		self::EDIT_CONTENT=>PrecurioTableConstants::CONTENT,
		self::EVENT_INVITED=>PrecurioTableConstants::EVENT
		
		);
		
	/**
	 * @param $type int - Type constant of the activity
	 * @return String Format in which to display activity message
	 */
	public static function getMessageFormat($type)
	{
		return self::$messageFormats[$type];
	}
	/**
	 * @param $type int - Type constant of the activity
	 * @return String Table name of the activity activity
	 */
	public static function getActivityTable($type)
	{
		return self::$activityTables[$type];
	}
	/**
	 * Determines whether a particular activity type is private.
	 * @param $type int
	 * @return Boolean
	 */
	public static function isPrivate($type)
	{
		switch($type)
		{
			case self::ADD_EVENT;
			case self::ADD_COMMENT;
			case self::ADD_EVENT;
			case self::EDIT_EVENT;
			case self::ADD_EVENT_PHOTO;
			case self::NEW_TASK;
			case self::EDIT_TASK;
			case self::COMPLETE_TASK;
			case self::FAILED_TASK;
			case self::CONTENT_APPROVED;
			case self::CONTENT_REJECTED;
			case self::TRANSFER_TASK;
			case self::NEW_WORKFLOW_REQUEST;
			case self::WORKLOW_APPROVAL_REQUEST;
			case self::WORKFLOW_APPROVED;
			case self::WORKFLOW_REJECTED;
			case self::NEW_CONTENT;
			case self::EDIT_CONTENT;
			case self::EVENT_INVITED;
			return true;
		}
		//it is non of the above		
		return false;
	}
	/**
	 * @param $user_id int Id of user performing the activity
	 * @param $type int type of the Activity
	 * @param $id int Id of the module that triggered the activity , AKA actual_activity_id.
	 * @param $url string url to view activity
	 * @param $subject_id user id of the person on which activity is acted upon
	 * @return int id of the new activity.
	 */
	public static function newActivity($user_id,$type,$id,$url='',$subject_id=0)
	{
		$data['user_id'] = $user_id;
		$data['type'] = $type;
		$data['activity_id'] = $id;
		$data['date_created'] = Precurio_Date::now()->getTimestamp();
		$data['url'] = $url;
		$data['subject_id'] = $subject_id;
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::ACTIVITY));
		$activity = $table->createRow($data);
		$activity_id = $activity->save();
		
		//now trigger notification.
		try
		{
			new Precurio_Notification($activity_id);
		}
		catch (Exception $e)
		{
			$log = Zend_Registry::get('log');
			$log->err("There was a problem with sending notifications \n".serialize($e));
		}
		
		return $activity_id;
	}
}

?>