<?php

require_once ('Zend/Config/Writer/Ini.php');

class Precurio_ConfigWriter extends Zend_Config_Writer_Ini
{
	/**
     * Prepare a value for INI
     *
     * @param  mixed $value
     * @return string
     */
    protected function _prepareValue($value)
    {
        if (is_integer($value) || is_float($value)) {
            return $value;
        } elseif (is_bool($value)) {
            return ($value ? 'true' : 'false');
        } elseif (strpos($value, '"') === false) {
        	$value = $this->escape($value);
            return '"' . $value .  '"';
        } else {
            /** @see Zend_Config_Exception */
            require_once 'Zend/Config/Exception.php';
            throw new Zend_Config_Exception('Value can not contain double quotes "');
        }
    }
    protected function escape($value)
    {
    	if($value=='$')
    	{
    		return '\\'.$value;
    	}
    	return $value;
    }
}

?>