<?php

require_once ('Zend/Mail.php');
require_once ('user/models/UserUtil.php');
class Precurio_Mail extends Zend_Mail {
	
	public function __construct()
	{
		parent::__construct();
		
		$config = Zend_Registry::get('config');
		$mail = $config->mail;
		$config = array();
		if($mail->use_auth)
		{
			$config = array('auth' => $mail->auth,
			'username' => $mail->username,
			'password' => $mail->password);	
			if($mail->use_secure)
				$config['ssl'] = $mail->ssl;
		}
		else
		{
			$config = array();
		}
		$config['port'] = $mail->port;
    	$tr = new Zend_Mail_Transport_Smtp($mail->server,$config);
		self::setDefaultTransport($tr);
    	$this->setFrom($mail->admin_email,$mail->admin_name);
	}
	
	/**
	 * @param $activity UserActivity
	 * @return null
	 */
	public function notify($activity)
	{
		$data = array();
		
		if(Precurio_Utils::isNull($activity->subject_id))//the activity is not on a subject.
		{
			if($activity->type == Precurio_Activity::NEW_CONTENT || $activity->type == Precurio_Activity::ADD_EVENT)
			{
				$config = Zend_Registry::get('config');
				if($config->allow_general_emails)//if public emails are allowed
					$data['to'] = $this->getEverybody();
			}
			else
				return;//no notification
		}
		else
		{
			$data['to'] = $this->getRecipients($activity);
		}
		
			
		
		$data['subject'] = $this->getMailSubject($activity->type);
		$data['body'] = $activity->getMessage(3);
		$data['from'] = $this->getFrom();
		
		$data['date_created'] = Precurio_Date::now()->getTimestamp();
		
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::MAIL_QUEUE));
		$row = $table->createRow($data);
		$row->save();
		return;
		$this->addTo($user->getEmail(),$user->getFullName());
		$this->setBodyHtml($activity->getMessage(2));
		$this->setSubject('New Precurio Activity');
		//$this->send();
			
	}
	/**
	 * Get the recipients of a notification based on the type of activity
	 * @param $activity UserActivity
	 * @return string
	 */
	public function getRecipients($activity)
	{
		$userFn = new UserUtil();
		$emails = array();
		if($activity->type == Precurio_Activity::ADD_COMMENT)
		{
			$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::COMMENTS));
			$comment = $table->find($activity->activity_id)->current();
			
			$allActivityComments = $table->fetchAll($table->select()->where('activity_id = ?',$comment->activity_id));
			foreach($allActivityComments as $activityComment)
			{
				$user = $userFn->getUser($activityComment->user_id);
				$emails[] =  $user->getEmail();
			}
		}
		elseif($activity->type == Precurio_Activity::NEW_CONTENT)//this section will only be called for group contents. 
		{
			$group_id = $activity->subject_id;
			$members = Group::getUsers($group_id);
			foreach($members as $user)
	     	{
	     		$emails[] =  $user->getEmail();
	     	}
			
		}
		else
		{
			$user = $userFn->getUser($activity->subject_id);
			$emails[] =  $user->getEmail();
		}
		
		//now remove repititions from array
		$emails = array_unique($emails);
		
		return implode(";",$emails);
	}
	
	private function getEverybody()
	{
		$table = new Zend_Db_Table(array('name'=>PrecurioTableConstants::USERS,'rowClass'=>'User'));
     	$users = $table->fetchAll($table->select()->where('active = ? ',1));
     	$emails = array();
     	foreach($users as $user)
     	{
     		$emails[] =  $user->getEmail();
     	}
     	
     	$emails = array_unique($emails);
		
		return implode(";",$emails);
	}
	
	private function getMailSubject($type)
	{
		return '[PRECURIO] New Activity';
	}
}

?>