<?php

class Precurio_Utils {
	public static function isNull($var)
	{
		return (is_null($var) || $var==='NULL' || $var==="" || $var=== "0" || $var== null || $var==='null'); 
	}
	/**
	 * this function returns the content of the second level arrary as those of the top level,
	 * such that a 2-Dimensional array becomes a linear array
	 * @param array $topArray
	 * @param int|string $column
	 * @return array
	 */
	public static function getSecondLevelArray($topArray,$column=null)
	{
		$newArray = array();
		foreach($topArray as $secondArray)
		{
			if(!is_array($secondArray))
				return $topArray;
			//if column is not null and its index is an array
			if(!self::isNull($column))
			{	
				if(is_array($secondArray[$column]))
					$newArray =	array_merge($newArray,$secondArray[$column]);
				else
					$newArray[] = $secondArray[$column];
			}
			else
				$newArray =	array_merge($newArray,$secondArray);
		}
		
		return $newArray;
	}
	public static function encrypt($str)
	{
		$x = new Precurio_EnDecryptText();
		return $x->Encrypt_Text($str);
	}
	public static function decrypt($str)
	{
		$x = new Precurio_EnDecryptText();
		return $x->Decrypt_Text($str);
	}
	/**
	 * @method strictly for testing purpose
	 * @param $var Object
	 * @return void
	 */
	public static function debug($var)
	{
		$log = Zend_Registry::get('log');
		$log->debug($var);
	}
	
	/**
	 * Converts a multi-dimensional array to a table string
	 * @param $arr Array
	 * @param $pathToController string, The path to the controller eg "/admin/poll/", must contain the last slash
	 * @return string
	 */
	public static function array2Table($arr,$header,$pathToController)
	{
		$str = "<table border='1' width='100%'>";

		
		$str .= "<tr>";
		foreach($header as $i)
		{
			$str .= "<th>$i </th>";
		}
		$str .= "<th></th>";
		$str .= "<th></th>";
		$str .= "<th><input type='checkbox' name='id' id='id'   onclick='selectAll(this)'>
		</th>";
		$str .= "</tr>";
		
		foreach($arr as $value)
		{
			$str .= "<tr>";
			$key = $value['id'];
			foreach($value as $prop=>$j)
			{
				if($prop === "id")continue;
				$str .= "<td>$j </td>";
			}
			$str .= "<td><a href='{$pathToController}view/id/{$key}'>View </a></td>";
			$str .= "<td><a href='{$pathToController}edit/id/{$key}'>Edit </a></td>";
			$str .= "<td><input type='checkbox' name='ids[]' id='ids[]'  value='$key'>
			</td>";
			$str .= "</tr>";
		}
		$str .= "</table>";
		return $str;
	}
	
	/**
	 * Returns a somewhat readable string
	 * @param $nameLength int length of the name
	 * @return String
	 */
	public function RandomName( $nameLength ) 
	{
	 $NameChars = 'abcdefghijklmnopqrstuvwxyz';
	 $Vouel = 'aeiou';
	 $Name = "";
	 for ($index = 1; $index <= $nameLength; $index++) 
	 { 
	    if ($index % 3 == 0)
	    {
	      $randomNumber = rand(1,strlen($Vouel));
	      $Name .= substr($Vouel,$randomNumber-1,1); 
	    }else
	      {
	        $randomNumber = rand(1,strlen($NameChars));
	        $Name .= substr($NameChars,$randomNumber-1,1);
	      } 
	 }
	 return $Name;
	}
	
}

?>